#include <unistd.h>
#include <esd.h>
#include <pulse/simple.h>
#include <alsa/asoundlib.h>
#include <stdlib.h>
#include <dlfcn.h>

int main(int argc,char **argv){
  snd_pcm_t *handle;
  int suspended;
  int sock;

  void *libpulse = NULL;
  pa_simple *s;
  pa_sample_spec ss;
  ss.format = PA_SAMPLE_S16NE;
  ss.channels = 2;
  ss.rate = 44100;
  pa_simple* (*_pa_simple_new)(const char *, const char *, pa_stream_direction_t, const char *, const char *, const pa_sample_spec *, const pa_channel_map *, const pa_buffer_attr *, int *) = NULL;
  void (*_pa_simple_free)(pa_simple *) = NULL;

  void *libesd = NULL;
  int (*_esd_open_sound)(const char *) = NULL;
  esd_standby_mode_t (*_esd_get_standby_mode)(int) = NULL;
  int (*_esd_close)(int) = NULL;

  void *libasound = NULL;
  int (*_snd_pcm_open)(snd_pcm_t **, const char *, snd_pcm_stream_t, int) = NULL;
  int (*_snd_pcm_close)(snd_pcm_t *) = NULL;

  libpulse=dlopen("libpulse-simple.so.0", RTLD_LAZY);
  if (libpulse){
    _pa_simple_new=dlsym(libpulse, "pa_simple_new");
    _pa_simple_free=dlsym(libpulse, "pa_simple_free");
    
    if ((s = _pa_simple_new(NULL, argv[1], PA_STREAM_PLAYBACK, NULL, "test", &ss, NULL, NULL, NULL))){
      _pa_simple_free(s);
      dlclose(libpulse);
      argv[0] = "padsp";
      if(execvp("padsp",argv) == 0)
	return 0;}}

  libasound=dlopen("libasound.so.2", RTLD_LAZY);
  if (libasound){
    _snd_pcm_open=dlsym(libasound, "snd_pcm_open");
    _snd_pcm_close=dlsym(libasound, "snd_pcm_close");

    if (_snd_pcm_open(&handle, "default", SND_PCM_STREAM_PLAYBACK, SND_PCM_NONBLOCK) == 0){
      _snd_pcm_close(handle);
      dlclose(libasound);
      argv[0] = "aoss";
      if(execvp("aoss",argv) == 0)
	return 0;}}

  libesd=dlopen("libesd.so.0", RTLD_LAZY);
  if (libesd){
    _esd_open_sound=dlsym(libesd, "esd_open_sound");
    _esd_get_standby_mode=dlsym(libesd, "esd_get_standby_mode");
    _esd_close=dlsym(libesd,"esd_close");

    /* don't wake up the beast while detecting */
    setenv("ESD_NO_SPAWN", "1", 1);
    if ((sock = _esd_open_sound(NULL)) >= 0){
      if (_esd_get_standby_mode(sock) == ESM_RUNNING){
	_esd_close(sock);
	dlclose(libesd);
	argv[0] = "esddsp";
	if(execvp("esddsp",argv) == 0)
	  return 0;}
      _esd_close(sock);
      dlclose(libesd);}}

  return execvp(argv[1],argv+1);}
